#include <stm32f10x.h>
#include <stm32f10x_gpio.h>
#include <stm32f10x_rcc.h>
#include <stm32f10x_usart.h>
#include <delay.h>
#include <nokia_lcd.h>
#include  <misc.h>

uint8_t FIFO_BUFF[128];
char temp_buff[16];
uint8_t hex = 0;
uint8_t getcount = 0, setcount = 0, setup = 0, posY=0, ps = 0;
uint32_t baudRate = 9600;

void USART1_IRQHandler(void)
{
  /* USART in Receiver mode */
  if (USART_GetITStatus(USART1, USART_IT_RXNE) == SET)
  {
	  FIFO_BUFF[getcount++]=USART1->DR;
	  if(getcount == 127)getcount=0;
  }
}

int main(void)
{
	RCC_ClocksTypeDef RCC_Clocks;
	RCC->CR|=((uint32_t)RCC_CR_HSEON);
	while (!(RCC->CR & RCC_CR_HSERDY)) {};
	RCC->CFGR &=~RCC_CFGR_SW; //   SW0, SW1.
	RCC->CFGR |= RCC_CFGR_SW_HSE; //  HSE   SW0=1.
	RCC_GetClocksFreq(&RCC_Clocks);

	lcd_pin_init();
	lcd_init();
	lcd_gotoxy(0,0);
	lcd_puts("uart terminal");
	_delay_ms(1500);
	lcd_clear();

	GPIO_InitTypeDef buttons_setup;
	buttons_setup.GPIO_Speed = GPIO_Speed_2MHz;
	buttons_setup.GPIO_Mode = GPIO_Mode_IPU;
	buttons_setup.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1;
	GPIO_Init(GPIOB,&buttons_setup);

	lcd_gotoxy(1,0);
	lcd_puts("speed 9600");

	lcd_gotoxy(1,1);
	lcd_puts("speed 19200");

	lcd_gotoxy(1,2);
	lcd_puts("speed 57600");

	lcd_gotoxy(1,3);
	lcd_puts("speed 115200");

	lcd_gotoxy(0,0);
	lcd_puts(">");

	while(setup != 5)
	{
		if(GPIO_ReadInputDataBit(GPIOB,GPIO_Pin_0)== 0)
		{
			switch (posY) {
				case 0:
					baudRate = 9600;
					break;
				case 1:
					baudRate = 19200;
					break;
				case 2:
					baudRate = 57600;
					break;
				case 3:
					baudRate = 115200;
					break;
				default:
					baudRate = 9600;
					break;
			}
			setup = 5;
		}
		if(GPIO_ReadInputDataBit(GPIOB,GPIO_Pin_1)== 0 && (ps == 0) )
		{
			lcd_gotoxy(0,posY);
			lcd_puts(" ");
			posY++;
			if (posY > 3)
			{
				posY = 0;

			}
			lcd_gotoxy(0,posY);
			lcd_puts(">");
			ps = 1;

		}
		if(GPIO_ReadInputDataBit(GPIOB,GPIO_Pin_1)== 1)
		{
			ps = 0;
		}
	}
	lcd_clear();
	lcd_puts(">");
	lcd_gotoxy(1,0);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);
	GPIO_InitTypeDef rx1_setup;
	rx1_setup.GPIO_Mode = GPIO_Mode_IPU;
	rx1_setup.GPIO_Pin = GPIO_Pin_10;
	rx1_setup.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_Init(GPIOA, &rx1_setup);

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1,ENABLE);
	USART_InitTypeDef uart1_setup;
	uart1_setup.USART_BaudRate = baudRate;
	uart1_setup.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	uart1_setup.USART_Mode = USART_Mode_Rx;
	uart1_setup.USART_Parity = USART_Parity_No;
	uart1_setup.USART_StopBits = USART_StopBits_1;
	uart1_setup.USART_WordLength = USART_WordLength_8b;
	USART_Init(USART1, &uart1_setup);

	USART_Cmd(USART1, ENABLE);

	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0);
	NVIC_InitTypeDef NVIC_InitStructure;

	/* Enable the USARTx Interrupt */
	NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);

	USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);

	while(1)
    {
		if(getcount != setcount)
		{
			if(hex == 1)
			{
			sprintf(temp_buff, "%x ",FIFO_BUFF[setcount++]);
			lcd_puts(temp_buff);
			}
			else {
				lcd_putch(FIFO_BUFF[setcount++]);
			}
			if(setcount == 127) setcount = 0;
			if(lcd_X >= 13  && lcd_Y == 7) lcd_clear();
		}
		if(GPIO_ReadInputDataBit(GPIOB,GPIO_Pin_1)== 0)
		{
			if(hex == 0)
			{
			hex = 1;
			}
			else {
				hex = 0;
			}
			ps = 1;
		}
		if(GPIO_ReadInputDataBit(GPIOB,GPIO_Pin_1)== 1)
		{
					ps = 0;
		}

    }
}
